<?php

namespace Hugh\AdminPermissionOptimize;

class EloquentUserProvider extends \Illuminate\Auth\EloquentUserProvider
{
    /**
     * Retrieve a user by their unique identifier.
     *
     * @param  mixed  $identifier
     * @return \Illuminate\Contracts\Auth\Authenticatable|null
     */
    public function retrieveById($identifier)
    {
        $model = $this->createModel();

        return $this->newModelQuery($model)
            ->with(['roles.permissions', 'permissions'])
            ->where($model->getAuthIdentifierName(), $identifier)
            ->first();
    }
}